<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                   	|
 |									|
 | This program is free software. You can redistribute it		|
 | and/or modify it under the terms of the GNU General Public License	|
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of     	|
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.     			|
 |                    							|
 +----------------------------------------------------------------------+
*/

chdir('../../');

$guest_account = true;

include ('./include/auth.php');
include_once('./plugins/reportit/lib_int/funct_validate.php');
include_once('./plugins/reportit/lib_int/funct_html.php');
include_once('./plugins/reportit/lib_int/funct_online.php');
include_once('./plugins/reportit/lib_int/funct_calculate.php');
include_once('./plugins/reportit/lib_int/funct_shared.php');
include_once('./plugins/reportit/lib_int/const_measurands.php');

/* ======== Validation ======== */
	safeguard_xss();
/* ============================ */


$measurand_actions 	= array( 2 => 'Delete');

if (!isset($_REQUEST['action'])) {
    $_REQUEST['action'] = '';
}

switch ($_REQUEST['action']) {
    case 'actions':
	form_actions();
	break;
    case 'measurand_edit':
	include_once($config["include_path"] . "/top_header.php");
	measurand_edit();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
    case 'save':
	form_save();
	break;
    default:
	include_once($config["include_path"] . "/top_header.php");
	standard();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
}


function standard() {

   global $colors, $measurand_actions;

    /* ================= input validation ================= */
	input_validate_input_number(get_request_var('id'));
    /* ==================================================== */

    $sql = "SELECT * FROM reportit_measurands WHERE template_id={$_GET['id']} ORDER BY id";
    $measurands_list	= db_fetch_assoc($sql);
    $template_name	= db_fetch_cell('SELECT description FROM reportit_templates WHERE id=' .$_GET['id']);

    $i = 0;

    //Number of measurands
    $number_of_measurands = count($measurands_list);
    $header_label	= "<b>Measurands </b>[Template:
			    <a style='color:yellow' href='cc_templates.php?action=template_edit&id={$_GET['id']}'>
			    $template_name</a>
			    ] [$number_of_measurands]";


    html_start_box("$header_label", "98%", $colors["header"], "2", "center", "cc_measurands.php?action=measurand_edit&template_id={$_GET['id']}");

    html_header_checkbox(array('Name', 'Abbreviation', 'Unit', 'Visible', 'Separate', 'Calculation Formula'));

    if (sizeof($measurands_list) > 0) {
	foreach($measurands_list as $measurand) {

	    form_alternate_row_color($colors["alternate"], $colors["light"], $i); $i++;
	    ?>
	    <td>
		<a class='linkEditMain' href="cc_measurands.php?action=measurand_edit&id=<?php print $measurand['id'];?>">
		    <?php print $measurand['description'];?>
		</a>
	    </td>
	    <td>
		<?php print $measurand['abbreviation'];?>
	    </td>
	    <td>
		<?php print $measurand['unit'];?>
	    </td>
	    <td>
		<?php html_checked_with_arrow($measurand['visible']);?>
	    </td>
	    <td>
		<?php html_checked_with_arrow($measurand['spanned']);?>
	    </td>
	    <td>
		<?php print $measurand['calc_formula'];?>
	    </td>
	    <td style="<?php print get_checkbox_style();?>" width='1%' align='right'>
		<input type='checkbox' style='margin: Opx;' name='chk_<?php print $measurand['id'];?>' title='Select'>
	    </td>
	    </tr>
	    <?php
	    }
    }else {
	print "<tr><td><em>No measurands</em></td></tr>\n";
    }
    html_end_box(true);

    $form_array = array('id' => array('method'	=> 'hidden_zero',
				      'value'	=> $_GET['id']));
    draw_edit_form(array( 'config' => array(),
			  'fields' => $form_array));

    draw_actions_dropdown($measurand_actions);
}



function form_save() {
    global $colors, $calc_var_names, $rounding;

    /* ================= input validation ================= */
	input_validate_input_number(get_request_var('id'));
	input_validate_input_number(get_request_var('template_id'));

	form_input_validate($_POST['measurand_description'], 'measurand_description', '', false, 3);
	form_input_validate($_POST['measurand_abbreviation'], 'measurand_abbreviation', '^[a-zA-Z0-9]+$', false, 3);
	form_input_validate($_POST['measurand_unit'], 'measurand_unit', '', false, 3);
	form_input_validate($_POST['measurand_formula'], 'measurand_formula', '', false, 3);
	form_input_validate($_POST['measurand_rounding'], 'measurand_rounding', '^[0-2]$', false, 3);
    /* ==================================================== */

    //Check if the abbreviation is in use.
    $sql 	= "SELECT COUNT(*) FROM reportit_measurands WHERE abbreviation='{$_POST['measurand_abbreviation']}'
		   AND id!='{$_POST['id']}' AND template_id='{$_POST['template_id']}'";
    $count 	= db_fetch_cell($sql);
    if($count != 0) session_custom_error_message('measurand_abbreviation', 'Duplicate abbreviation');

    //Check calculation formula
    if(!is_error_message_field('measurand_formula')) {
	$calc 		= $_POST['measurand_formula'];
	$intersizes 	= get_intersizes($_POST['id'], $_POST['template_id']);
	$calc_var_names = array_keys(get_possible_variables($_POST['template_id']));
	$error 		= validate_calc_formula($calc, $intersizes, $calc_var_names);
	if($error      != 'VALID') session_custom_error_message('measurand_formula', $error);
    }

    //Check possible dependences with other measurands
    if(!is_error_message_field('measurand_abbreviation') && $_POST['id'] != 0) {
	$dependences 	= array();
	$new		= $_POST['measurand_abbreviation'];

	$sql		= "SELECT abbreviation FROM reportit_measurands WHERE id={$_POST['id']}";
	$old		= db_fetch_cell($sql);

	if($old != $new) {
	    $sql	= "SELECT id, calc_formula FROM reportit_measurands WHERE template_id={$_POST['template_id']}
			    AND id >{$_POST['id']}
			    AND calc_formula LIKE '%$old%'";
	    $dependences= db_fetch_assoc($sql);
	    foreach($dependences as $key => $value) {
		    $value['calc_formula'] 	= str_replace($old, $new, $value['calc_formula']);
		    $dependences[$key]		= $value;
	    }
	}

	//Check if interim results are used in other measurands
	if(isset($_POST['measurand_spanned'])) {
	    $sql	= "SELECT COUNT(*) FROM reportit_measurands WHERE template_id={$_POST['template_id']}
			    AND id >{$_POST['id']}
			    AND calc_formula LIKE '%$old:%'";
	    $count	= db_fetch_cell($sql);
	    if($count != 0) session_custom_error_message('measurand_spanned', 'Interim results are used by other measurands.');
	}
    }

    $measurand_data 			= array();
    $measurand_data['id']		= $_POST['id'];
    $measurand_data['template_id']	= $_POST['template_id'];
    $measurand_data['description']	= $_POST['measurand_description'];
    $measurand_data['abbreviation']	= strtoupper($_POST['measurand_abbreviation']);
    $measurand_data['unit']		= $_POST['measurand_unit'];
    $measurand_data['visible']		= isset($_POST['measurand_visible']) 		? 1 : 0;
    $measurand_data['spanned']		= isset($_POST['measurand_spanned']) 		? 1 : 0;
    $measurand_data['calc_formula']	= $_POST['measurand_formula'];
    $measurand_data['rounding']		= $_POST['measurand_rounding'];

    if(is_error_message()) {
	header("Location: cc_measurands.php?action=measurand_edit&id={$_POST['id']}&template_id={$_POST['template_id']}");
    }else {
	//Save data
	sql_save($measurand_data, 'reportit_measurands');

	//Update dependences if it's necessary
	if(isset($dependences)) update_formulas($dependences);

	//Return to list view if it was an existing report
	header("Location: cc_measurands.php?&id={$_POST['template_id']}");
	raise_message(1);
    }
}



function measurand_edit() {

    global $colors, $template_actions, $rounding;

    /* ================= input validation ================= */
	input_validate_input_number(get_request_var('id'));
    /* ==================================================== */

    if (!empty($_GET['id'])) {
	$measurand_data		= db_fetch_row('SELECT * FROM reportit_measurands WHERE id=' . $_GET['id']);
	$measurand_var		= db_fetch_row('SELECT * FROM reportit_variables WHERE measurand_id=' . $_GET['id']);
	$header_label 		= '[edit: ' . $measurand_data['description'] . ']';

    }else {
	$header_label 		= '[new]';
    }

    session_custom_error_display();

    $measurand_id 	= (isset($_GET['id']) ? $_GET['id'] : '0');
    $template_id	= (isset($_GET['template_id']) ? $_GET['template_id'] : $measurand_data['template_id']);
    $measurand_var_id	= (isset($measurand_var['id']) ? $measurand_var['id'] : 0);

    $form_array = array(
	    		'id'			=> array(
			    'method'		=> 'hidden_zero',
			    'value'		=> $measurand_id
			    ),
			'template_id'		=> array(
			    'method'		=> 'hidden_zero',
			    'value'		=> $template_id
			    ),
			'var_id'		=> array(
			    'method'		=> 'hidden_zero',
			    'value'		=> $measurand_var_id,
			    ),
			'measurand_header'	=> array(
			    'friendly_name'	=> 'General',
			    'method'		=> 'spacer'
			    ),
			'measurand_description'	=> array(
			    'friendly_name' 	=> 'Name',
		            'method' 		=> 'textbox',
			    'max_length'	=> '100',
			    'description'	=> 'The explanation given to this measurand.<br>Available as legend and tooltip.',
			    'value' 		=> (isset($measurand_data['description']) ? $measurand_data['description'] : '')
			    ),
			'measurand_abbreviation'=> array(
			    'friendly_name'	=> 'Abbreviation',
			    'method'		=> 'textbox',
			    'max_length'	=> '4',
			    'description'	=> 'Define a unique abbreviation for this<br> measurand with max. 4 letters/numbers.',
			    'value'		=> (isset($measurand_data['abbreviation']) ? $measurand_data['abbreviation'] : '')
			    ),
			'measurand_unit'	=> array(
			    'friendly_name' 	=> 'Unit',
		            'method' 		=> 'textbox',
			    'max_length'	=> '25',
			    'description'	=> 'The unit given to this measurand.<br>e.g. "Bits/s"',
			    'value' 		=> (isset($measurand_data['unit']) ? $measurand_data['unit'] : '')
			    ),
			'measurand_visible'	=> array(
			    'friendly_name'	=> 'Visible',
    			    'method'		=> 'custom',
			    'description'	=> 'Choose \'enable\' if this measurand should be shown in the report.',
			    'value'		=> "<input type='checkbox' id='measurand_visible' name='measurand_visible'". ((!isset($measurand_data['visible']) || $measurand_data['visible'] == true) ? ' checked' :'') . '>',
			    ),
			'measurand_spanned'	=> array(
			    'friendly_name'	=> 'Separate',
    			    'method'		=> 'custom',
			    'description'	=> 'Choose \'enable\' if this measurand will only have one result<br>
						    instead of one for every Round Robin Archive and it\'s result<br>should be displayed separately.',
			    'value'		=> "<input type='checkbox' id='measurand_spanned' name='measurand_spanned'". ((isset($measurand_data['spanned']) && $measurand_data['spanned'] == true) ? ' checked' :'') . '>',
			    ),
			'measurand_rounding'	=> array(
			    'friendly_name'	=> 'Rounding',
			    'method'		=> 'drop_array',
			    'array'		=> $rounding,
			    'description'	=> 'Choose the way of displaying this measurand\'s results.',
			    'value'		=> (isset($measurand_data['rounding']) ? $measurand_data['rounding'] : '1' )
			    ),
			'measurand_formula'	=> array(
			    'friendly_name' 	=> 'Calculation Formula',
		            'method' 		=> 'custom',
			    'description'	=> 'This measurand\'s mathematical definition.<br>Click on the operators or operands below.',
			    'value' 		=> "<input type='text' id='measurand_formula' name='measurand_formula' size='40' maxlength='200'" . (isset($measurand_data['calc_formula']) ? "value='{$measurand_data['calc_formula']}'" : "" ) . '>'
			    )
			);

    html_start_box("<strong>Measurand configuration</strong> $header_label", "98%", $colors["header"], "2", "center", "");

    draw_edit_form(array(
			'config' => array(),
			'fields' => $form_array
			));
    html_end_box();





    html_graph_start_box(1);
	html_calc_syntax($measurand_id, $template_id);
    html_graph_end_box();
    echo "<p>";

    form_save_button("cc_measurands.php?&id=$template_id");


    //A little bit of java
    ?><script language="JavaScript">
	function add_to_calc(name) {
	    fieldId = document.getElementById('measurand_formula');
	    old = fieldId.value;
	    fieldId.value = old + name;
	    fieldId.focus();
	    fieldId.value = fieldId.value;
	}
    </script>
    <?php

}


function form_actions() {
    global $colors, $measurand_actions;

    // ================= input validation =================
        input_validate_input_number(get_request_var('id'));
    // ====================================================


    if (isset($_POST['selected_items'])) {
	$selected_items = unserialize(stripslashes($_POST['selected_items']));

	if ($_POST['drp_action'] == '2') { // DELETE MEASURANDS
	    $sql = 'DELETE FROM reportit_measurands WHERE ' . array_to_sql_or($selected_items, 'id');
	    db_execute($sql);

	    //Check if it is necessary to lock the report template
	    if(stat_autolock_template($_POST['id'])) set_autolock_template($_POST['id']);
	    /*
	    $sql = "SELECT COUNT(*) FROM reportit_measurands WHERE template_id={$_POST['template_id']}";
	    $count = db_fetch_cell($sql);
	    if($count == 0) db_execute("UPDATE reportit_templates SET locked=1 WHERE id={$_POST['template_id']}");
	    */
	}
	header("Location: cc_measurands.php?id={$_POST['id']}");
	exit;
    }


    //Debug all measurands
    if ($_POST['drp_action'] == '1') {
        $result = debug_measurands($_POST['id']);

	//Start with HTML
	include_once('./include/top_header.php');
	html_start_box("<strong>Debugging</strong>", "98%", $colors["header_panel"], "2", "center", "");
	echo "<form action='cc_measurands.php' method='post'>\n";
	?>
	    <tr>
		<td colspan='2' bgcolor='#F5F5F5'><br>
		    <span class='textinfo'><b>&nbsp;Summary</b></span><hr width='99%'>
		</td>
	    </tr>
	    <tr bgcolor='#F5F5F5'>
	        <td width='20%'>
		    &nbsp;Status:<br>
		    &nbsp;Number of measurands:<br>
		    &nbsp;Number of intermediate results:<br>
		    <br>
		    &nbsp;Initial values (11):<br>
		    <?php
			foreach($result['function_results'] as $key => $value) {
			    echo "&nbsp;System function: $key<br>";
			}
		    ?>
		</td>
		<td align='LEFT'>
		    <?php
			if($result['status'] == 'failed') {
			    print "<span style='color:red'><b>failed</b></span><br>";
			}else {
			    print "successful<br>";
			}
			print "{$result['number_of_measurands']}<br>
			       {$result['number_of_intersizes']}<br>";
			print "<br>";
			print "0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10<br>";
			foreach($result['function_results'] as $key => $value) {
			    echo "$value<br>";
			}
		    ?>
		</td>
	    </tr>
	<?php

	foreach($result['measurands'] as $key => $array) {
	    print "<tr bgcolor='#F5F5F5'>
	    		<td colspan='2'><br>
			    <span class='textinfo'>
			    <a href='cc_measurands.php?action=measurand_edit&id={$array['id']}'>
				<b>&nbsp;$key</b>
			    </a>
			    </span><hr width='99%'>
			</td>
		    </tr>
		    <tr bgcolor='#F5F5F5'>
			<td width='20%'>";
	    foreach($array as $index => $value) {
		    if($index != 'id') print "&nbsp;$index:<br>";
	    }
	    echo "</td><td>";
	    foreach($array as $index => $value) {
		    if($index != 'id') print "$value<br>";
	    }
	    echo "</td></tr>";
	}

	echo "<tr bgcolor='#F5F5F5'><td>&nbsp;</td><td></td></tr>";

        print " <tr>
		<td>
		</td>
		<td align='right'>
		    <a href='cc_measurands.php?&id={$_POST['id']}'><img src='../../images/button_go.gif' alt='OK' align='absmiddle' border='0'></a>
		</td>
	    </tr>";

	exit;
    }


    //Set preconditions
    $ds_list = ''; $i = 0;

    foreach($_POST as $key => $value) {
	if(strstr($key, 'chk_')) {
	    //Fetch report id
	    $id = substr($key, 4);
	    $measurand_ids[] = $id;
	    // ================= input validation =================
			input_validate_input_number($id);
	    // ====================================================

	    //Fetch report description
	    $measurand_description 	= db_fetch_cell('SELECT description FROM reportit_measurands WHERE id=' . $id);
	    $ds_list[$measurand_description] = '';
	}
    }
    include_once('./include/top_header.php');
    html_start_box("<strong>" . $measurand_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "2", "center", "");
    print "<form action='cc_measurands.php' method='post'>\n";


    if ($_POST['drp_action'] == '2') { //DELETE REPORT
	print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
			<p>Are you sure you want to delete the following measurand configuration(s)?<p>
			Notice: If there are no other measurands left after this process, the report template will be locked automatically.<p>";
			if(is_array($ds_list)) {
			    print "Measurand configuration(s):";
			    foreach($ds_list as $key => $value) {
				print "<li><b>$key</b><br>";
			    }
			    print "</li>";
			}
	print "     </td>
		</tr>\n";

	if (!is_array($ds_list)) {
	    print "<tr><td bgcolor='#" . $colors['form_alternate1']. "'><span class='textError'>You must select at least one report.</span></td></tr>\n";
	    $save_html = '';
	}else {
	    $save_html = "<input type='image' src='../../images/button_yes.gif' alt='Save' align='absmiddle'>";
        }
    }

    print " <tr>
		<td align='right' bgcolor='#eaeaea'>
		    <input type='hidden' name='id' value='{$_POST['id']}'>
		    <input type='hidden' name='action' value='actions'>
		    <input type='hidden' name='selected_items' value='" . (isset($measurand_ids) ? serialize($measurand_ids) : '') . "'>
		    <input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
		    <a href='cc_measurands.php?id={$_POST['id']}'><img src='../../images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
		    $save_html
		</td>
	    </tr>";

    html_end_box();
    include_once('./include/bottom_footer.php');
}
?>