<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                   	|
 |									|
 | This program is free software. You can redistribute it		|
 | and/or modify it under the terms of the GNU General Public License	|
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of     	|
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.     			|
 |                    							|
 +----------------------------------------------------------------------+
*/

chdir('../../');

$guest_account = true;

include ('./include/auth.php');
include_once('./plugins/reportit/lib_int/funct_validate.php');
include_once('./plugins/reportit/lib_int/funct_online.php');
include_once('./plugins/reportit/lib_int/const_reports.php');
include_once('./plugins/reportit/lib_int/funct_shared.php');
include_once('./plugins/reportit/lib_int/funct_html.php');

/* ============== Validation ============== */
    safeguard_xss('', '<report_title>');
/* ======================================== */


$report_actions 	= array( 1 => 'Run Report', 2 => 'Delete', 3 => 'Duplicate');
$link_array		= array('description', 'template_description', '', '', 'public', '');
$link_array_admin	= array('description', 'username', 'template_description', '', '', 'public', 'scheduled', '');
$list_of_modes		= array('ASC', 'DESC');

if (!isset($_REQUEST['action'])) {
    $_REQUEST['action'] = '';
}


switch ($_REQUEST['action']) {
    case 'actions':
	form_actions();
	break;
    case 'report_edit':
	include_once($config["include_path"] . "/top_header.php");
	report_edit();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
    case 'report_add':
	include_once($config["include_path"] . "/top_header.php");
	report_wizard();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
    case 'save':
	form_save();
	break;
    default:
	include_once($config["include_path"] . "/top_header.php");
	standard();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
}



function report_wizard() {
    global $colors, $config;

    //Clean up $_SESSION
    if(isset($_SESSION['reportit'])) unset($_SESSION['reportit']);

    html_wizard_header('New Report', 'cc_reports.php');

    //Fetch all report templates which are available for a new report
    $templates_list	= array();
    $templates 		= array();
    $sql 		= "SELECT id, description FROM reportit_templates WHERE locked=0";
    $templates_list 	= db_fetch_assoc($sql);

    if (sizeof($templates_list) == 0) {
	print "<tr><td bgcolor='#" . $colors['form_alternate1']. "'><span class='textError'>There are no templates available.</span></td></tr>\n";
	$save_html = '';
    }else {
	foreach($templates_list as $tmp) {
	    $templates[$tmp['id']] = $tmp['description'];
	}

	$save_html = "<input type='image' src='" . $config['url_path'] . "plugins/reportit/images/button_next.gif' alt='Next' align='absmiddle'>";

	print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
			<br>
			<p>Choose a template your report should depends on.<br>
			</p>
			<b>Available report templates</b><br>";
			form_dropdown('template', $templates, '', '', '', '', '');
	print "     </td>
		</tr>\n";
    }

    html_wizard_footer('report_edit', 'cc_reports.php', $save_html);
}



function standard() {
    global $colors, $report_actions, $minutes, $link_array, $link_array_admin, $list_of_modes;

    $affix 	  = '';
    $myId	  = my_id();
    $myName 	  = my_name();
    $reportAdmin  = re_admin();
    $tmz	  = (read_config_option('reportit_show_tmz') == 'on') ? '('.date('T').')' : '';
    $enable_tmz	  = read_config_option('reportit_use_tmz');

    /* ================= Input validation ================= */
    if(isset($_GET['sort']) && isset($_GET['mode'])) {
	if(!in_array($_GET['sort'], $link_array_admin) || !in_array($_GET['mode'], $list_of_modes))
	    die_html_custom_error();
    }
    /* ==================================================== */

    if(isset($_GET['sort']) && isset($_GET['mode'])) {
        if($reportAdmin) {
    	    $affix = " ORDER BY {$_GET['sort']} {$_GET['mode']}";
        }else {
    	    $affix = " WHERE user_id = $myId ORDER BY {$_GET['sort']} {$_GET['mode']}";
        }
    }else {
        if($reportAdmin) {
    	    $affix = " ORDER BY description, username";
        }else {
    	    $affix = " WHERE user_id = $myId ORDER BY description, username";
        }
    }

    $sql = 'SELECT	a.*, b.description AS template_description, c.username, b.locked
	    FROM	reportit_reports AS a
	    LEFT JOIN	reportit_templates AS b
	    ON 		b.id 	= a.template_id
	    LEFT JOIN	user_auth AS c
	    ON		c.id	= a.user_id' . $affix;
    $report_list = db_fetch_assoc($sql);


    //Number of reports
    $number_of_reports = count($report_list);

    //Start HTML Output
    html_start_box("<b>Report configurations</b> [$number_of_reports]", "98%", $colors["header"], "2", "center", "cc_reports.php?action=report_add");

    if ($reportAdmin) {
	$desc_array = array('Description', 'Owner', 'Template', "Period $tmz from - to", "Last run $tmz/ Runtime", 'Public', 'Scheduled', 'Data Items');
	html_header_checkbox(html_sorted_with_arrows( $desc_array, $link_array_admin, 'cc_reports.php'));
    }else {
	$desc_array = array('Description', 'Template', "Period $tmz from - to", "Last run $tmz/ Runtime", 'Public', 'Data Items');
	html_header_checkbox(html_sorted_with_arrows( $desc_array, $link_array, 'cc_reports.php'));
    }

    $i = 0;

    if (sizeof($report_list) > 0) {
	foreach($report_list as $report) {
	    form_alternate_row_color($colors["alternate"], $colors["light"], $i); $i++;
		?>
		<td>
			<a class='linkEditMain' href="cc_reports.php?action=report_edit&id=<?php print $report["id"];?>">
			    <?php print $report["description"];
				if($report['in_process']) print "<b style='color: #FF0000'>&nbsp;*In process*</b>";
			    ?>
			</a>
		</td>
		<?php
		    if($reportAdmin) print "<td>{$report['username']}</td>";
		?>
		<td>
			<?php print $report['template_description'];
			    if($report['locked']) print "<b style='color: #FF0000' title='Template has been locked temporarily.'>&nbsp;*Locked*</b>";
			?>
		</td>
		<td>
			<?php
			    if ($report['sliding']== true && $report['last_run'] == 0) {
				$dates = get_timespan($report['preset_timespan'], $report['present'], $enable_tmz);
				print (date(config_date_format(), strtotime($dates['start_date'])) . " - " . date(config_date_format(), strtotime($dates['end_date'])));
			    }else {
				print (date(config_date_format(), strtotime($report['start_date'])) . " - " . date(config_date_format(), strtotime($report['end_date'])));
			    }
			?>
		</td>
		<td>
			<?php
			    if($report['last_run'] == '0000-00-00 00:00:00') {
			      	print "- not available -";
			    }else {
				list($date, $time) = explode(' ', $report['last_run']);
			        print (date(config_date_format(), strtotime($date)) . '&nbsp;' . $time . '&nbsp;&nbsp;/&nbsp;' . $report['runtime']);
			    }
			?>

		</td>
		<td>
			<?php html_checked_with_arrow($report['public']);?>
		</td>
		<?php
		    if($reportAdmin) {
			print "<td>";
			html_checked_with_arrow($report['scheduled']);
			print "</td>";
		    }
		    print "<td><a class='linkEditMain' href='cc_rrdlist.php?&id={$report["id"]}'>
			    Edit Data Items
		    	    </a></td>";
		    if(!$report['locked'] && !$report['in_process']) {
			?>
			<td style="<?php print get_checkbox_style();?>" width="1%" align="right">
			<input type='checkbox' style='margin: Opx;' name='chk_<?php print $report["id"];?>' title="Select">
			</td>
			<?php
		    }else {
			print "<td align='right'>[<b style='color: #FF0000' title='Template has been locked temporarily.'>L</b>]</td>";
		    }
		?>
	    </tr>
	    <?php
	}
    }else {
	print "<tr><td><em>No reports</em></td></tr>\n";
    }

    html_end_box(true);

    draw_actions_dropdown($report_actions);
}



function form_save() {
    global $colors, $templates, $timespans, $frequency;

    /* ================= Input Validation ================= */
	input_validate_input_number(get_request_var('id'));
	input_validate_input_number(get_request_var('template_id'));
	input_validate_input_number(get_request_var('user_id'));

	form_input_validate($_POST['report_description'], 'report_description',NULL ,false,3);

	//Validate start- and end date if we need them
	if (!isset($_POST['report_dynamic'])) {

	    if(!preg_match('/^\d{4}\-\d{2}\-\d{2}$/', $_POST['report_start_date'])) {
		session_custom_error_message('report_start_date', 'Invalid date');
	    }

	    if(!preg_match('/^\d{4}\-\d{2}\-\d{2}$/', $_POST['report_end_date'])) {
		session_custom_error_message('report_end_date', 'Invalid date');
	    }

	    if(!is_error_message()) {
		list($ys, $ms, $ds) = explode("-", $_POST['report_start_date']);
		list($ye, $me, $de) = explode("-", $_POST['report_end_date']);

		if(!checkdate($ms, $ds, $ys)) session_custom_error_message('report_start_date', 'Invalid date');
		if(!checkdate($me, $de, $ye)) session_custom_error_message('report_end_date', 'Invalid date');

		if (($start_date = mktime(0,0,0,$ms,$ds,$ys)) > ($end_date = mktime(0,0,0,$me,$de,$ye)) || $ys > $ye || $ys > date("Y")) {
		    session_custom_error_message('report_start_date', 'Invalid date');
		}
		if (($end_date = mktime(0,0,0,$ms,$ds,$ys)) > mktime() || $ye > date("Y")) {
		    session_custom_error_message('report_start_date', 'Invalid date');
		}
	    }
	}
	locked($_POST['template_id']);
    /* ==================================================== */

    $report_data['id']	  	  	= $_POST['id'];
    $report_data['description']   	= $_POST['report_description'];
    $report_data['user_id']		= $_POST['user_id'];
    $report_data['template_id']		= $_POST['template_id'];
    $report_data['preset_timespan']	= isset($_POST['report_timespan']) ? $timespans[$_POST['report_timespan']] : '';

    $report_data['public']	  	= isset($_POST['report_public']) ? 1 : 0;
    $report_data['start_date']		= isset($_POST['report_start_date']) ? $_POST['report_start_date'] : '';
    $report_data['end_date']		= isset($_POST['report_end_date']) ? $_POST['report_end_date'] : '';

    $report_data['sliding']		= isset($_POST['report_dynamic']) ? 1 : 0;
    $report_data['present']		= isset($_POST['report_present']) ? 1 : 0;
    $report_data['subhead']		= isset($_POST['report_subhead']) ? 1 : 0;
    $report_data['scheduled']		= isset($_POST['report_schedule']) ? 1 : 0;
    $report_data['frequency']		= isset($_POST['report_schedule_frequency']) ? $frequency[$_POST['report_schedule_frequency']] : '';
    $report_data['last_run']		= '';

    //Now we've to keep our variables
    $vars	= array();
    $rvars 	= array();
    $var_data	= array();

    foreach($_POST as $key => $value) {
	    if(strstr($key, 'var_')) {
		$id = substr($key, 4);
		$vars[$id] = $value;
	    }
    }

    $sql	= "SELECT a.*, b.id as b_id, b.value FROM reportit_variables AS a
		   LEFT JOIN reportit_rvars as b
		   on a.id = b.variable_id AND report_id = {$_POST['id']}
		   WHERE a.template_id = {$_POST['template_id']}";

    $rvars	= db_fetch_assoc($sql);

    foreach($rvars as $key => $v) {
	$value = $vars[$v['id']];

	if( $v['input_type'] == 1) {
	    $i = 0;
    	    $array = array();
	    $a = $v['min_value'];
	    $b = $v['max_value'];
	    $c = $v['stepping'];

	    for($i=$a; $i <= $b; $i+=$c) {
		$array[] = $i;
	    }

	    $value = $array[$value];

    	    if( $value > $v['max_value'] || $value < $v['min_value']) die_html_custom_error('', true);
	}else {
	    if( $value > $v['max_value'] || $value < $v['min_value']) {
		session_custom_error_message($v['name'], "{$v['name']} is out of range");
		break;
	    }
	}
	//If there's no error we can go on
	$var_data[] = array('id' 		=> (($v['b_id'] != NULL) ? $v['b_id'] : 0),
			    'template_id'	=> $_POST['template_id'],
			    'report_id' 	=> $_POST['id'],
			    'variable_id' 	=> $v['id'],
			    'value' 		=> $value);
    }

    //Now start saving or go back
    if(is_error_message()) {
	header('Location: cc_reports.php?action=report_edit&id=' . $_POST['id']);
    }else {
	//Save data
	$report_id = sql_save($report_data, 'reportit_reports');

	//Save the variables
	foreach($var_data as $data) {
	    if($_POST['id'] == 0) $data['report_id'] = $report_id;
	    sql_save($data, 'reportit_rvars');
	}

	//Create rrdlist_table
	if($_POST['id'] == 0) {
	    create_rrd_table($report_id);
	}

	//Return to list view if it was an existing report
	if($_POST['id']!='0') {
	    header('Location: cc_reports.php');
	    raise_message(1);
	}else {
	    header('Location: cc_reports.php?action=report_edit&id=' . $report_id);
	}
    }
}


function report_edit() {
    global $colors, $templates, $timespans, $graph_timespans, $frequency;

    /* ================= input validation ================= */
        input_validate_input_number(get_request_var('id'));
	input_validate_input_number(get_request_var_post('template'));
    /* ==================================================== */
    my_report(get_request_var('id'));

    session_custom_error_display();


    if (!empty($_GET['id'])) {
	$report_data		= db_fetch_row('SELECT * FROM reportit_reports WHERE id=' . $_GET['id']);
	$header_label 		= '[edit: ' . $report_data['description'] . ']';

	//Update report_data array for presets
	$report_data['preset_timespan'] = array_search($report_data['preset_timespan'], $timespans);
        //Update report_data array for schedule frequency
        $report_data['frequency'] 	= array_search($report_data['frequency'], $frequency);

	//Blue link settings
	$href 	= 'cc_rrdlist.php?action=rrdlist_add&id=' . $_GET['id'];
	$text 	= 'Create Data Items';
	$link[] = array('href' =>$href, 'text' =>$text);

	$sql 	= "SELECT pre_filter FROM reportit_templates WHERE id={$report_data['template_id']}";
	$filter = db_fetch_cell($sql);
	$tmp 	= db_fetch_assoc("SELECT id, description FROM reportit_templates WHERE pre_filter='$filter'");

    }else {
	$header_label	= '[new]';
    }


    $id	= (isset($_GET['id']) ? $_GET['id'] : '0');

    if(isset($_POST['template'])) {
	if(!isset($_SESSION['reportit']['template'])) $_SESSION['reportit']['template'] = $_POST['template'];
    }

    $template_id= (isset($report_data['template_id']) ? $report_data['template_id'] : $_SESSION['reportit']['template']);


    //Check if the template template has been locked.
    locked($template_id);

    $template	= db_fetch_cell("SELECT description FROM reportit_templates WHERE id=$template_id");
    if($id != 0) html_blue_link( $link);
    html_start_box("<strong>Report configuration</strong> $header_label", "98%", $colors["header"], "2", "center", "");

    $form_array = array(
	    		'id'			=> array(
			    'method'		=> 'hidden_zero',
			    'value'		=> (isset($_GET['id']) ? $_GET['id'] : '0')
			    ),
			'user_id'		=> array(
			    'method'		=> 'hidden_zero',
			    'value' 		=> (isset($report_data['user_id']) ? $report_data['user_id'] : my_id())
			    ),
			'template_id'		=> array(
			    'method'		=> 'hidden_zero',
			    'value'		=> $template_id,
			    ),
			'report_header'		=> array(
			    'friendly_name'	=> 'General',
			    'method'		=> 'spacer',
			    ),
			'report_description'	=> array(
			    'friendly_name' 	=> 'Name',
		            'method' 		=> 'textbox',
			    'max_length'	=> '100',
			    'description'	=> 'The name given to this report',
			    'value' 		=> (isset($report_data['description']) ? $report_data['description'] : '')
			    ),
			'report_template'	=> array(
			    'friendly_name'	=> 'Template',
			    'method'		=> 'custom',
			    'max_length'	=> '100',
			    'description'	=> 'The template your report depends on',
			    'value'		=> $template,
			    ),
			'report_public'		=> array(
			    'friendly_name'	=> 'Public',
			    'method'		=> 'custom',
		    	    'default'		=> 'false',
		    	    'description'	=> "By using this function everyone can see this report under tab 'reports'",
		    	    'value'		=> "<input type='checkbox' id='report_public' name='report_public'". ((!isset($report_data['public']) || $report_data['public'] == true) ? ' checked' :'') . "> ",
		    	    ),
			'report_subhead'	=> array(
			    'friendly_name'	=> 'Subhead',
			    'method'		=> 'custom',
		    	    'default'		=> 'false',
		    	    'description'	=> 'Enable/disable using an additional subhead for every data item<br>
						    that will be on display under the interface description.',
		    	    'value'		=> "<input type='checkbox' id='report_subhead' name='report_subhead'". ((!isset($report_data['subhead']) || $report_data['subhead'] == true) ? ' checked' :'') . "> ",
		    	    )
			);


   $form_array_2 = array(
   			'report_header_2'	=> array(
			    'friendly_name'	=> 'Sliding Time Frame',
			    'method'		=> 'spacer',
			    ),
			'report_dynamic'	=> array(
			    'friendly_name'	=> 'Enable Sliding Time Frame',
			    'method'		=> 'custom',
			    'default'		=> 'false',
		    	    'description'	=> 'Enable/disable using a sliding timeframe instead of an static one.',
		    	    'value'		=> "<input type='checkbox' id='report_dynamic' name='report_dynamic' onClick='dynamic()'". ((!isset($report_data['sliding']) || $report_data['sliding'] == true) ? ' checked' :'') . "> ",
		    	    ),
			'report_timespan'	=> array(
			    'friendly_name'	=> 'Sliding Time Frame',
			    'method'		=> 'drop_array',
		    	    'description'	=> 'The time frame you want to analyse in relation to current time.<br>This means calendar days, calendar months and calendar years.',
		    	    'value'		=> (isset($report_data['preset_timespan']) ? $report_data['preset_timespan'] :''),
		    	    'array'		=> $timespans
		    	    ),
			'report_present'	=> array(
			    'friendly_name'	=> 'Down To The Present Day',
			    'method'		=> 'custom',
			    'default'		=> 'false',
		    	    'description'	=> 'Define sliding time frame up to date',
		    	    'value'		=> "<input type='checkbox' id='report_present' name='report_present'". ((!isset($report_data['present']) || $report_data['present'] == true) ? ' checked' :'') . "> ",
		    	    ),
			'report_start_date'	=> array(
			    'friendly_name' 	=> 'Static Time Frame - Start Date (From)',
		            'method' 		=> 'custom',
			    'description'	=> 'To define the start date use the following format: <b>yyyy-mm-dd</b>',
    			    'value' 		=> "<input type='text' id='report_start_date' name='report_start_date' size='10' maxlength='200' value='" . (isset($report_data['start_date']) ? "{$report_data['start_date']}'" : "yyyy-mm-dd'"). '>'
			    ),
			'report_end_date'	=> array(
			    'friendly_name' 	=> 'Static Time Frame - End Date (To)',
		            'method' 		=> 'custom',
			    'description'	=> 'To define the start date use the following format: <b>yyyy-mm-dd</b>',
    			    'value' 		=> "<input type='text' id='report_end_date' name='report_end_date' size='10' maxlength='200' value='" . (isset($report_data['end_date']) ? "{$report_data['end_date']}'" : "yyyy-mm-dd'"). '>'
			    )
	    		);

    $form_array_3 = array(
   			'report_header_4'	=> array(
			    'friendly_name'	=> 'Scheduling',
			    'method'		=> 'spacer',
			    ),
			'report_schedule'	=> array(
			    'friendly_name'	=> 'Enable scheduled reporting',
			    'method'		=> 'custom',
		    	    'default'		=> 'false',
		    	    'description'	=> 'Enable/disable scheduled reporting. Sliding time frame should be enabled',
		    	    'value'		=> "<input type='checkbox' id='report_schedule' name='report_schedule' onClick='schedule()'". ((isset($report_data['scheduled']) && $report_data['scheduled'] == true) ? ' checked' :'') . ">",
		    	    ),

		'report_schedule_frequency'	=> array(
			    'friendly_name'	=> 'Frequency',
			    'method'		=> 'drop_array',
		    	    'description'	=> 'Select the frequency for processing this report. Be sure that the correct crontab is running.',
		    	    'value'		=> (isset($report_data['frequency']) ? $report_data['frequency'] :''),
		    	    'array'		=> $frequency
		    	    )
			);

    $form_array_4 = array('report_header_5'	=> array(
			    'friendly_name'	=> 'Scheduling',
			    'method'		=> 'spacer',
			    ));




    draw_edit_form(array(
			'config' => array(),
			'fields' => $form_array
			));
    html_end_box();

    html_start_box("", "98%", $colors["header"], "2", "center", "");
    draw_edit_form(array(
			'config' => array(),
			'fields' => $form_array_2
			));
    html_end_box();

    //Draw necessary variables
    $template_variables = html_report_variables($id, $template_id );
    if($template_variables != FALSE) {
	html_start_box("", "98%", $colors["header"], "2", "center", "");
	draw_edit_form(array(
			    'config' => array(),
			    'fields' => $template_variables
			    ));
	html_end_box();
    }


    if (re_admin()) {
	html_start_box("", "98%", $colors["header"], "2", "center", "");
        draw_edit_form(array(
			'config' => array(),
			'fields' => $form_array_3
			));
	html_end_box();
    }

    form_save_button('cc_reports.php');

    //Now we need some javascript to make it dynamic
    ?>
	<script language="JavaScript">

	    dynamic();

    	    function dynamic() {
		if (document.getElementById('report_dynamic').checked){
		    document.getElementById('report_start_date').value='yyyy-mm-dd';
		    document.getElementById('report_start_date').disabled=true;
		    document.getElementById('report_end_date').value='yyyy-mm-dd';
		    document.getElementById('report_end_date').disabled=true;

                    document.getElementById('report_present').disabled=false;
		    document.getElementById('report_timespan').disabled=false;
		}else {
		    document.getElementById('report_start_date').disabled=false;
		    document.getElementById('report_end_date').disabled=false;
		    document.getElementById('report_present').disabled=true;
		    document.getElementById('report_timespan').disabled=true;
		}
	    }

	    function schedule() {
		if(document.getElementById('report_schedule').checked){
		    document.getElementById('report_dynamic').checked = true;
		    dynamic();
		}



	    }
	</script>
    <?php
}


function form_actions() {

    global $colors, $report_actions;

    if (isset($_POST['selected_items'])) {
	$selected_items = unserialize(stripslashes($_POST['selected_items']));

	if ($_POST['drp_action'] == '2') { // DELETE REPORT
	    $report_datas = db_fetch_assoc('SELECT id FROM reportit_reports WHERE ' . array_to_sql_or($selected_items, 'id'));

	    if (sizeof($report_datas) > 0) {
		foreach ($report_datas as $report_data) {
		    db_execute('DELETE FROM reportit_reports WHERE id=' . $report_data['id']);
		    db_execute('DROP TABLE IF EXISTS reportit_rrdlist_' . $report_data['id']);
		    db_execute('DROP TABLE IF EXISTS reportit_results_' . $report_data['id']);
		}
	    }
	}elseif ($_POST['drp_action'] == '3') { //DUPLICATE REPORT TEMPLATE

	    for ($i=0;($i<count($selected_items));$i++) {
		/* ================= input validation ================= */
		input_validate_input_number($selected_items[$i]);
		/* ==================================================== */

		$report_data = db_fetch_row('SELECT * FROM reportit_reports WHERE id = ' . $selected_items[$i]);
		$report_data['id'] = 0;
		$report_data['description'] = str_replace("<report_title>", $report_data['description'], $_POST['report_addition']);
		sql_save($report_data, 'reportit_reports');

		//Get new dataset's (auto_incrementing) id
		$sql = "SELECT id FROM reportit_reports WHERE description ='{$report_data['description']}'";
		$new_id = db_fetch_cell($sql);

		//In Hope of compatibility to all people which have not MySQL 4.1 or higher:
		//Create table for saving the rrdlist
		create_rrd_table($new_id);

		//Copy original rrdlist table  to new rrdlist table
		$sql = "INSERT INTO reportit_rrdlist_" . $new_id . " SELECT * FROM reportit_rrdlist_" . $selected_items[$i];
		db_execute($sql);
	    }
	}
	header('Location: cc_reports.php');
	exit;
    }

    //Set preconditions
	$ds_list = ''; $i = 0;

    foreach($_POST as $key => $value) {

	if(strstr($key, 'chk_')) {
	    //Fetch report id
	    $id = substr($key, 4);
	    $report_ids[] = $id;
	    // ================= input validation =================
			input_validate_input_number($id);
	    // ====================================================

	    //Fetch report description
	    $report_description 	= db_fetch_cell('SELECT description FROM reportit_reports WHERE id=' . $id);
	    $ds_list[$report_description] = '';
	}
    }

    //For running report jump to cc_run.php!
    if ($_POST['drp_action'] == '1') { // RUNNING REPORT
	//Only one report is allowed to run at the same time, so select the first one:
	if(isset($report_ids)) {
    	    $report_id = $report_ids[0];

	    //Update $_SESSION
	    $_SESSION['run'] = '1';

	    //Jump to cc_run.php
	    header('Location: cc_run.php?action=calculation&id=' . $report_id);
	    exit;
	}
    }

    include_once('./include/top_header.php');
    html_start_box("<strong>" . $report_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "2", "center", "");
    print "<form action='cc_reports.php' method='post'>\n";

    if ($_POST['drp_action'] == '2') { //DELETE REPORT
	print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
			<p>Are you sure you want to delete the following report configuration(s)?<br>
			</p>";
			if(is_array($ds_list)) {
			    print "Report configuration(s):";
			    foreach($ds_list as $key => $value) {
				print "<li><b>$key</b><br>";
			    }
			    print "</li>";
			}
	print "     </td>
		</tr>\n";

    }elseif ($_POST['drp_action'] == '3') { // DUPLICATE REPORT
	print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors['form_alternate1']. "'>
			<p>When you click \"yes\", the following report configuration will be duplicated. You can
			   optionally change the title format for the new report.
			</p>";
			if(is_array($ds_list)) {
			    print "Report configuration:";
			    foreach($ds_list as $key => $value) {
				print "<li><strong>$key</strong></li><br>";
			    }
			}
			print "<p><strong>Title Format:</strong><br>";
			form_text_box("report_addition", "<report_title> (1)", "", "255", "30", "text");
	print "		</p>
		    </td>
		</tr>\n";
    }


    if (!is_array($ds_list)) {
	print "<tr><td bgcolor='#" . $colors['form_alternate1']. "'><span class='textError'>You must select at least one report.</span></td></tr>\n";
	$save_html = '';
    }else {
	$save_html = "<input type='image' src='../../images/button_yes.gif' alt='Save' align='absmiddle'>";
    }

    print " <tr>
		<td align='right' bgcolor='#eaeaea'>
		    <input type='hidden' name='action' value='actions'>
		    <input type='hidden' name='selected_items' value='" . (isset($report_ids) ? serialize($report_ids) : '') . "'>
		    <input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
		    <a href='cc_reports.php'><img src='../../images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
		    $save_html
		</td>
	    </tr>";

    html_end_box();
    include_once('./include/bottom_footer.php');}
?>
