<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                   	|
 |									|
 | This program is free software. You can redistribute it		|
 | and/or modify it under the terms of the GNU General Public License	|
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of     	|
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.     			|
 |                    							|
 +----------------------------------------------------------------------+
*/


chdir('../../');

$guest_account = true;

include ('./include/auth.php');
include_once('./plugins/reportit/lib_int/funct_validate.php');
include_once('./plugins/reportit/lib_int/funct_shared.php');
include_once('./plugins/reportit/lib_int/funct_html.php');
include_once('./plugins/reportit/lib_int/funct_online.php');
include_once('./plugins/reportit/lib_int/funct_export.php');
include_once('./plugins/reportit/lib_int/const_view.php');

/* ======== Validation ======== */
	safeguard_xss();
/* ============================ */

$link_array	= array('description', 'user_id', 'template_description', '', '', '');
$list_of_modes	= array('ASC', 'DESC');


if (!isset($_REQUEST["action"])) {
    $_REQUEST["action"] = "";
}

switch ($_REQUEST["action"]) {
    case 'show_report':
	if(only_viewer()) {
	    include_once($config["include_path"] . "/top_graph_header.php");
	}else {
    	    include_once($config["include_path"] . "/top_header.php");
	}
	show_report();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
    case 'show_graph_overview':
	show_graph_overview();
	break;
    case 'export':
	export();
	break;
    default:
	if(only_viewer()) {
	    include_once($config["include_path"] . "/top_graph_header.php");
	}else {
    	    include_once($config["include_path"] . "/top_header.php");
	}
	standard();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
}


function export() {
    global $colors, $config;

    /* ================= input validation ================= */
        input_validate_input_number(get_request_var('id'));
    /* ==================================================== */
        my_report(get_request_var('id'), TRUE);

    //Fetch export settings (global)
    $export_settings	   = db_fetch_assoc("SELECT * FROM settings WHERE name like '%reportit%'");

    //Fetch export settings (user)
    $id 		   = my_id();
    $export_graph_settings = db_fetch_assoc("SELECT name, value FROM settings_graphs WHERE name like '%reportit%' AND user_id = '$id' AND name != 'reportit_exp_header'");

    //Tranform settings
    $export_settings    = array_merge($export_settings, $export_graph_settings);
    $exp_settings	= array();
    foreach($export_settings as $settings) {
	$exp_settings[$settings['name']] = $settings['value'];
    };

    //Check read/write permissions
    $path = $config['base_path'] . '/plugins/reportit/exports/' . $_GET['type'];
    if(!is_readable($path)) die_html_custom_error('Read permission denied - Check your system configuration', true);
    if(!is_writeable($path)) die_html_custom_error('Write permission denied - Check your system configuration', true);


    //Prepare data for export
    $report_data	= get_prepared_report_data($_GET['id'],'export');
    $export_function	= "export_to_{$_GET['type']}";

    //Call export function
    $filename 		= $export_function($report_data, $exp_settings);
    header("Location: ./exports/{$_GET['type']}/$filename");
}


function standard() {
    global $colors, $config, $link_array, $list_of_modes;

    /* ================= input validation ================= */
    if(isset($_GET['sort']) && isset($_GET['mode'])) {
	if(!in_array($_GET['sort'], $link_array) || !in_array($_GET['mode'], $list_of_modes))
	    die_html_custom_error();
    }
    /* ==================================================== */


    $affix	= '';
    $userid 	= my_id();
    $tmz	= (read_config_option('reportit_show_tmz') == 'on') ? '('.date('T').')' : '';

    $sql = "SELECT	a.*, b.description 				AS template_description
	    FROM 	reportit_reports 				AS a
	    INNER JOIN	reportit_templates 				AS b
	    ON 		b.id			= a.template_id
	    WHERE      (a.public 		= 1			OR
			a.user_id 		= $userid)
	    AND		a.last_run 	       != 0";

    // Check if user wants to sort list by something
    if(isset($_GET['sort']) && isset($_GET['mode'])) {
	$sql = $sql . " ORDER BY {$_GET['sort']} {$_GET['mode']}";
    }
    $report_list 	= db_fetch_assoc($sql);
    $number_of_reports  = count($report_list);

    // Check export types
    $sql 		= "SELECT * FROM settings WHERE name = 'reportit_csv'";
    $export_types	= db_fetch_assoc($sql);

    //Tranform settings
    $exp_settings	= array();
    foreach($export_types as $settings) {
	if ($settings['value'] == 'on') {
	    $name = substr($settings['name'], 9);
	    $exp_settings[$name] = $settings['value'];
	}
    }

    $number_of_exp_types= count($exp_settings);

    //----- Start HTML output -----
    html_start_box("<b>Public Reports</b> [$number_of_reports]", "98%", $colors["header"], "2", "center", "");
    $desc_array = array('Description', 'Owner', 'Template', "Period $tmz from - to", "Last run $tmz");
    if ($number_of_exp_types != 0) {
	$link_array[]='';
	$desc_array[]='Export';
    }
    html_header(html_sorted_with_arrows( $desc_array, $link_array, 'cc_view.php'));


    // Set preconditions
    $i = 0;

    // Build report list
    if (sizeof($report_list) > 0) {
	foreach($report_list as $report) {
	    form_alternate_row_color($colors["alternate"], $colors["light"], $i); $i++;

	    ?>
		    <td>
			<a class='linkEditMain' href="cc_view.php?action=show_report&id=<?php print $report["id"];?>">
			    <?php print $report["description"];?>
			</a>
		    </td>
	    	    <td>
			<?php
			    $ownerId = $report['user_id'];
		    	    print other_name($ownerId);
			?>
		    </td>
		    <td>
			<?php print $report['template_description'];?>
	    	    </td>
		    <td>
			<?php print (date(config_date_format(), strtotime($report['start_date'])) . " - " . date(config_date_format(), strtotime($report['end_date'])));?>
		    </td>
		    <td>
			<?php 
				list($date, $time) = explode(' ', $report['last_run']);
				print (date(config_date_format(), strtotime($date)) . '&nbsp;' . $time . '&nbsp;&nbsp;/&nbsp;' . $report['runtime']);
			?>
		    </td>
			<?php
			if ($number_of_exp_types != 0) {
			    print "<td>";
			    foreach($exp_settings as $key => $value) {
				print "<a class='linkEditMain' href='cc_view.php?action=export&type=$key&id={$report['id']}'>.$key</a>&nbsp;";
			    }
			    print "</td>";
			}
			?>
		</tr>
	    <?php

	}
    }

    html_end_box(true);
    //-----------------------------
}



function show_report() {
    global $colors;

    /* ================= input validation ================= */
        input_validate_input_number(get_request_var('id'));
    /* ==================================================== */
    my_report(get_request_var('id'), TRUE);


    // Check whether user wants to sort view by something
    if(isset($_GET['sort']) && isset($_GET['mode'])) {
	$data = get_prepared_report_data($_GET['id'], 'view', $_GET['sort'], $_GET['mode']);
    }else {
	$data = get_prepared_report_data($_GET['id'],'view');
    }

    $report_data	= $data['report_data'];
    $report_header	= $report_data['description'];
    $report_results	= $data['report_results'];
    $mea		= $data['report_measurands'];
    $ds_description	= array();
    $enable_tmz		= read_config_option('reportit_use_tmz');
  
    // Extract result description;
    list($rs_description, $count_rs) 	= explode('-', $report_data['rs_def']);
    $rs_description 			= ($rs_description == '') ? FALSE : explode('|', $rs_description);
    if($rs_description !== FALSE) {
        foreach($rs_description as $key => $id) {
	    if(!isset($data['report_measurands'][$id]['visible']) || $data['report_measurands'][$id]['visible'] == 0) {
		$count_rs--;
		unset($rs_description[$key]);
	    }
	}
    }

    // Extract 'Overall' description;
    list($ov_description, $count_ov)	= explode('-', $report_data['sp_def']);

    $ov_description 			= ($ov_description == '') ? FALSE : explode('|', $ov_description);
    if($ov_description !== FALSE) {
	foreach($ov_description as $key => $id) {
	    if(!isset($data['report_measurands'][$id]['visible']) || $data['report_measurands'][$id]['visible'] == 0) {
		$count_ov--;
		unset($ov_description[$key]);
	    }
	}
    }

    // Extract datasource description;
    if($count_rs > 0) $ds_description 	= explode('|', $report_data['ds_description']);
    if($count_ov > 0) $ds_description[] = 'overall';


    //----- Start HTML output -----
    html_custom_header_box('Reports', $report_header, 'cc_view.php', 'reports');
    html_report_start_box();

    foreach($ds_description as $description) {
	$counter = ($description != 'overall') ? $count_rs : $count_ov;
	print "<th colspan='$counter' height='10' bgcolor='E5E5E5'>$description</th>";
    }

    //Additional Informations
    $start = date(config_date_format(), strtotime($data['report_data']['start_date']));
    $end   = date(config_date_format(), strtotime($data['report_data']['end_date']));    
    $title = "Reporting&nbsp;period:&nbsp;$start&nbsp;-&nbsp;$end"; 

    print "</tr><tr title='$title'>
		    <td class='textSubHeaderDark' align='left'>
			<b>Data Description<br>
			<a title='ascending' href='cc_view.php?action=show_report&id={$_GET['id']}&sort=name_cache&mode=ASC'><font size='2' color='FFFF00'>&#8593</font></a>
			<a title='descending' href='cc_view.php?action=show_report&id={$_GET['id']}&sort=name_cache&mode=DESC'><font size='2' color='FFFF00'>&#8595</font></a>
			</b>
		    </td>";

    foreach($ds_description as $datasource) {
	$name	= ($datasource != 'overall') ? $rs_description : $ov_description;

	if($name !== FALSE) {
	    foreach($name as $id) {
		$var	= ($datasource != 'overall') ? $datasource.'__'.$id : 'spanned__'.$id;
		$title 	= $mea[$id]['description'];

		if($mea[$id]['visible']) {
	    	    print  "<td class='textSubHeaderDark' align='right'>
			    <b title='$title'>{$mea[$id]['abbreviation']}&nbsp;[{$mea[$id]['unit']}]<br>
			    <a title='ascending' href='cc_view.php?action=show_report&id={$_GET['id']}&sort=$var&mode=ASC'><font size='2' color='FFFF00'>&#8593</font></a>
	    	    	    <a title='descending' href='cc_view.php?action=show_report&id={$_GET['id']}&sort=$var&mode=DESC'><font size='2' color='FFFF00'>&#8595</font></a>
			    </b>
			    </td>";
		}
	    }
	}
    }

    echo "</tr>";

    // Set preconditions
    $i = 0;

    if (sizeof($report_results) > 0) {
	foreach($report_results as $result) {
	    form_alternate_row_color($colors["alternate"], $colors["light"], $i); $i++;

            $tmz = $enable_tmz ? str_replace(' ', '&nbsp;', $result['timezone']) : '';
	    $title = "{$result['start_time']}&nbsp;-&nbsp;{$result['end_time']}&nbsp;$tmz&#10;"
		     ."{$result['start_day']}&nbsp;-&nbsp;{$result['end_day']}";

	    print "<td title='$title'>
			<a class='linkEditMain' href='cc_view.php?action=show_graph_overview&id={$_GET["id"]}&rrd={$result["id"]}'>
			    {$result["name_cache"]}
			</a>";
	    if($report_data['subhead']) print "<br>{$result['description']}";
	    echo '</td>';

	    foreach($ds_description as $datasource) {
    		$name	= ($datasource != 'overall') ? $rs_description : $ov_description;

		    foreach($name as $id) {
			$rounding = $mea[$id]['rounding'];
    			$var 	= ($datasource != 'overall') ? $datasource.'__'.$id : 'spanned__'.$id;
			$value 	= $result[$var];
			echo "<td align='right' title='$title'>";

			if($value == NULL) {
		    	    print "NA";
			}elseif ($value == 0 || $rounding == 0) {
		    	    print $value;
			}else {
			    print get_unit($value, $rounding);
			}
			echo '</td>';
		    }
	    }
	}
    }
    echo '</table>';
}


function show_graph_overview() {

    $sql = "SELECT DISTINCT 	c.local_graph_id
	    FROM 		data_template_data 				AS a
	    INNER JOIN 		data_template_rrd 				AS b
	    ON 			b.local_data_id 	= a.local_data_id
	    INNER JOIN 		graph_templates_item 				AS c
	    ON 			c.task_item_id 		= b.id
	    WHERE 		a.local_data_id 	= {$_GET['rrd']}";
    $local_graph_id = db_fetch_cell($sql);

    $data = get_prepared_report_data($_GET['id'],'view');
    $report_data	= $data['report_data'];

    $start = strtotime($report_data['start_date']);
    $end   = strtotime($report_data['end_date'] . ' 23:59:59');
    $end  += (strpos(PHP_OS, 'WIN')) ? 0 : 1;

    header("Location: ../../graph.php?action=zoom&local_graph_id=$local_graph_id&rra_id=0&graph_start=$start&graph_end=$end");
}
?>
