<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                   	|
 |									|
 | This program is free software. You can redistribute it		|
 | and/or modify it under the terms of the GNU General Public License	|
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of     	|
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.     			|
 |                    							|
 +----------------------------------------------------------------------+
*/


function html_custom_header_box($header, $hlink, $href = '', $link = '') {
    global $colors;
    
    echo "<table align='center' width='98%' cellpadding='3' cellspacing='1' border='0' bgcolor='{$colors['header']}'>
		<tr>
		    <td class='textHeaderDark' align='left'>";
    print 		"<b>$header&nbsp;</b>[$hlink]
		    <td>";
    if($href !='' && $link !='')
	    print  "<td class='textHeaderDark' align='right'>
			 <b><a class='linkOverDark' href='$href'>&raquo;&nbsp;$link</a></b>
		    </td>";
    echo "	</tr>
	  </table>
	  <br>";
}


function html_error_box($message, $site, $jump, $link){
    global $colors;
    
    html_wizard_header('Error', '$site');
    print "<tr><td bgcolor='#" . $colors['form_alternate1'] . "'><span class='textError'>$message</span></td></tr>\n";
    html_wizard_footer($jump, $link, '');
}


function html_wizard_header($title, $site) {
    global $colors;
    
    html_start_box("<b>$title</b>", '60%', $colors['header_panel'], '2', 'center', '');
    echo "<form action='$site' method='post'\n";
}


function html_wizard_footer($jump, $link, $save_html) {
    print " <tr>
		<td align='right' bgcolor='eaeaea'>
		    <input type='hidden' name='action' value='$jump'>
		    <a href='$link'><img src='../../images/button_cancel2.gif' alt='Chancel' align='absmiddle' border='0'></a>
		    $save_html
		</td>
	    </tr>";
    html_end_box();
    include_once('./include/bottom_footer.php');
}


function html_report_start_box() {
    global $colors;
    echo "<table align='center' width='98%' cellpadding='3' cellspacing='1' border='0' bgcolor='{$colors['header_panel']}'>
	    <tr><td bgcolor='#E5E5E5'></td>";
    
}


function html_blue_link(& $data) {
    // Create a blue HTML link in an existing table
    echo   "<table width='98%' align='center'>
	    	<tr> 
		    <td class='textinfo' valign='top' align='right'>";
			foreach($data as $link) {
			print "<span style='color: #c16921'>*</span><a href='{$link['href']}'>{$link['text']}</a><br>";
			}
    echo 	   "</td>
		</tr>
	    </table><br>";
}		


function html_sorted_with_arrows(& $desc_array, & $link_array, $page, $id = FALSE) {
    $text	= '';
    $result 	= array();
    if($id) $id = '&id=' . $id;
    foreach($desc_array as $key => $description) {
	$text	= $description . ' ';
	if($link_array[$key] != '') {	    
	    $text      .= "<a href='$page?$id&sort={$link_array[$key]}&mode=ASC'><font size='2' color='FFFF00'></b>&#8593<b></font></a>"; 
	    $text      .= "<a href='$page?$id&sort={$link_array[$key]}&mode=DESC'><font size='2' color='FFFF00'></b>&#8595<b></font></a>";
	}
	$result[]	= $text;
    }
    return $result;
}


function html_checked_with_arrow($value) {
    if($value == TRUE) {
	echo '<b>&radic;</b>';
    }else {
	echo '';
    }
}








function html_calc_syntax($measurand_id, $template_id) {
    global $rubrics;
    
    $rubrics['Variables'] = get_possible_variables($template_id);
    
    $intersizes = array_flip(get_intersizes($measurand_id, $template_id, true));
    $rubrics['Interim Results'] = $intersizes;

    //Create an box to get an overview of possible commands    
    foreach($rubrics as $key => $value) {
	echo "<tr><td width='15%' align='left' valign='top'><b>$key:</b></td><td>";
	echo "&nbsp;&nbsp";
	foreach($value as $name => $description) {
	    $value = str_replace('<br>', '', $name);
	    echo "<font color='blue' onClick=add_to_calc('$value') title='$description' style='cursor:pointer;'>$name&nbsp;&nbsp;</font>";
	}
	echo "</td><td width='5%'><td></tr>";
    }
}


function html_report_variables($report_id, $template_id) {

    //Define some variables  
    $array		= array();  
    $form_array_vars 	= array();
    $input_types 	= array(1 => 'drop_array', 2 => 'textbox');

    //Load the possible variables
    $sql	= "SELECT a.*, b.value FROM reportit_variables AS a
		    LEFT JOIN reportit_rvars AS b
		    ON a.id = b.variable_id AND report_id = $report_id
		    WHERE a.template_id = $template_id";
		    
    $variables	= db_fetch_assoc($sql);
    
    if(count($variables) == 0) {
	$sql = "SELECT * FROM reportit_variables WHERE template_id = $template_id";
	$variables = db_fetch_assoc($sql);
    }
    
    //Exit if there are no variables necessary for using this template
    if(count($variables) == 0) return FALSE;
    
    //Put the headerline in
    $header = array('friendly_name'	=> 'Variables',
		    'method'		=> 'spacer');
    $form_array_vars['report_var_header'] =  $header;
    
    //Start with a transformation
    foreach($variables as $v) {
	$value	= (isset($v['value']) ? $v['value'] : $v['default_value']);
	$method = $input_types[$v['input_type']];
	$index 	= 'var_' . $v['id'];
	
	if($method == 'drop_array') {
	    $i 		= 0;
	    $array 	= array();

	    
	    $a 		= $v['min_value'];
	    $b 		= $v['max_value'];
    	    $c 		= $v['stepping'];
	    	    
	    for( $i = $a; $i <= $b; $i+=$c) {
		$array[]=strval($i);
	    }
	        
	    $var = array('friendly_name'=> ($v['name']),
			 'method' 	=> $method,
			 'description' 	=> $v['description'],
			 'value'	=> array_search($value, $array),
			 'array'	=> $array);
	   
	    $form_array_vars[$index] = $var;
	}else {
	    $var = array('friendly_name'=> $v['name'],
			 'method' 	=> $method,
			 'description' 	=> $v['description'],
			 'max_length'	=> 10,
			 'value'	=> $value,
			 'default'	=> $v['default_value']);
	    $form_array_vars[$index] = $var;	    
	}
    }
    return $form_array_vars;
}
?>