<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                   	|
 |									|
 | This program is free software. You can redistribute it		|
 | and/or modify it under the terms of the GNU General Public License	|
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of     	|
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.     			|
 |                    							|
 +----------------------------------------------------------------------+
*/


function owner($report_id) {
    $sql = "SELECT b.username, b.full_name FROM reportit_reports as a
	    INNER JOIN user_auth as b
	    ON b.id = a.user_id
	    WHERE a.id = $report_id";
    $tmp = db_fetch_row($sql);
    $owner = "{$tmp['full_name']} ({$tmp['username']})";
    return $owner;
}


function get_prepared_report_data($report_id, $type, $order='description', $mode='ASC') {
    //Prepare all necessary data for export, view or something else
    
    //Report configuration + template description
    $sql =	"SELECT a.*, 
			b.description as template_name
		 FROM 	reportit_reports 						AS a
		 INNER JOIN	reportit_templates						AS b
		 ON	a.template_id				= b.id
		 WHERE 	a.id					= '$report_id' ";
    $report_data		= db_fetch_row($sql);
    
    
    //Read out all measurand configurations
    $report_measurands		= array();
    $sql 			= "SELECT * FROM reportit_measurands WHERE template_id = {$report_data['template_id']}";
    $tmps			= db_fetch_assoc($sql);
    foreach($tmps as $tmp) {
	$report_measurands[$tmp['id']] = $tmp;
    }
    $report_data['owner']	= owner($report_id);

    //Read out all variables
    $report_variables		= array();
    $sql			= "SELECT a.name, b.value FROM reportit_variables as a 
				    INNER JOIN reportit_rvars as b 
				    ON a.id = b.variable_id AND b.id = $report_id 
				    WHERE a.template_id = {$report_data['template_id']}";
    $report_variables		= db_fetch_assoc($sql);
					
    switch ($type) {
	    case 'view':
			    $sql = "SELECT	a.*,
						b.*, c.name_cache
				    FROM 	reportit_results_$report_id 			AS a
				    INNER JOIN 	reportit_rrdlist_$report_id 			AS b
				    ON 		a.id 				= b.id
				    INNER JOIN 	data_template_data 				AS c
				    ON 		c.local_data_id 		= a.id
				    ORDER BY    $order $mode";
	    break;
	    case 'export':
			    $sql = "SELECT	c.name_cache,
						b.*,
			    			a.*
				    FROM 	reportit_results_$report_id 			AS a
				    INNER JOIN 	reportit_rrdlist_$report_id 			AS b
				    ON 		a.id 				= b.id
				    INNER JOIN 	data_template_data 				AS c
				    ON 		c.local_data_id 		= a.id

				    ORDER BY    c.name_cache";
	    break;
    }
    $report_results	= db_fetch_assoc($sql);

    $dummy = array( 'report_data'	=> $report_data, 
		    'report_results'	=> $report_results,
		    'report_measurands'	=> $report_measurands,
		    'report_variables'	=> $report_variables);
    return $dummy;
}


function get_timespan($preset_timespan, $present, $enable_tmz = FALSE) {

    //Set preconditions
    $today = ($enable_tmz) ? gmdate('Y-m-d') : date('Y-m-d');
    list($ys, $ms, $ds) = explode("-", $today);
    list($ye, $me, $de) = explode("-", $today);    
    
    //Set report start date
    switch ($preset_timespan)  {
	case 'Today':
	    break;
	case 'Last 1 Day':
	    $ds-=1;$de-=1;
	    break;
	case 'Last 2 Days':
	    $ds-=2;$de-=1;
	    break;
	case 'Last 3 Days':
	    $ds-=3;$de-=1;
	    break;
	case 'Last 4 Days':
	    $ds-=4;$de-=1;
	    break;
	case 'Last 5 Days':
	    $ds-=5;$de-=1;
	    break;
	case 'Last 6 Days':
	    $ds-=6;$de-=1;
	    break;
	case 'Last 7 Days':
	    $ds-=7;$de-=1;
	    break;
	case 'Last Week (Sun - Sat)':
	    $ds -= ($enable_tmz) ? 7 + gmdate('w') : 7 + date('w');
	    $de = $ds + 6;
	    break;
	case 'Last Week (Mon - Sun)':
	    $ds -= ($enable_tmz) ? 6 + gmdate('w') : 6 + date('w');
	    $de = $ds + 6;
	    break;	
	case 'Last 14 Days':
	    $ds-=14;$de-=1;
	    break;
	case 'Last 21 Days':
	    $ds-=21;$de-=1;
	    break;
	case 'Last 28 Days':
	    $ds-=28;$de-=1;
	    break;
	case 'Current Month':
	    $ds=1;$de-=1;
	    break;
	case 'Last Month':
	    $ms-=1;$ds=1;$de=0;
	    break;
	case 'Last 2 Months':
	    $ms-=2;$ds=1;$de=0;
	    break;
	case 'Last 3 Months':
	    $ms-=3;$ds=1;$de=0;
	    break;
	case 'Last 4 Months':
	    $ms-=4;$ds=1;$de=0;
	    break;
	case 'Last 5 Months':
	    $ms-=5;$ds=1;$de=0;
	    break;
	case 'Last 6 Months':
	    $ms-=6;$ds=1;$de=0;
	    break;
	case 'Current Year':
	    $ms=1;$ds=1;$de-=1;
	    break;	
	case 'Last Year':
	    $ms=1;$ds=1;$ys-=1;$me=1;$de=0;
	    break;
	case 'Last 2 Years':
	    $ms=1;$ds=1;$ys-=2;$me=1;$de=0;
	    break;
	default:
	    break;
    }
    
    $dates = array();
    
    $dates['start_date'] 	= ($enable_tmz) ? gmdate('Y-m-d', gmmktime(0,0,0, $ms, $ds, $ys)) : date('Y-m-d', mktime(0,0,0, $ms, $ds, $ys));

    if($present) {
        $dates['end_date'] 	= $today;	
    }else {
	$dates['end_date'] 	= ($enable_tmz) ? gmdate('Y-m-d', gmmktime(0,0,0, $me, $de, $ye)) : date('Y-m-d', mktime(0,0,0, $me, $de, $ye));
    }
    
    return $dates;
}


function get_unit($value, $rounding) {
    global $threshold, $binary, $decimal, $IEC;
    
    if($rounding == 1) {
	$k	= ($IEC) ? 'K' : 'k';
	$i 	= ($IEC) ? 'i' : '';
	$pre	= &$binary;
    }else {
	$k	= 'k';
	$i	= '';
	$pre	= &$decimal;
    }
    
    $sign       = ($value < 0)? -1 : 1;
    $value      = abs($value);
    
    switch($value) {
	case ($value >= $pre['Y']): 			//YOTTA
	    $value   /= $pre['Y'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " Y$i");
	    break;
	case ($value >= $pre['Y']*$threshold):
	    $value   /= $pre['Y'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " Y$i");
	    break;
	case ($value >= $pre['Z']): 			//ZETTA
	    $value   /= $pre['Z'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " Z$i");
	    break;
	case ($value >= $pre['Z']*$threshold):
	    $value   /= $pre['Z'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " Z$i");
	    break;    
	case ($value >= $pre['E']): 			//EXA
	    $value   /= $pre['E'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " E$i");
	    break;
	case ($value >= $pre['E']*$threshold):
	    $value   /= $pre['E'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " E$i");
	    break;   
	case ($value >= $pre['P']): 			//PETA
	    $value   /= $pre['P'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " P$i");
	    break;
	case ($value >= $pre['P']*$threshold):
	    $value   /= $pre['P'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " P$i");
	    break;
	case ($value >= $pre['T']): 			//TERA
	    $value   /= $pre['T'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " T$i");
	    break;
	case ($value >= $pre['T']*$threshold):
	    $value   /= $pre['T'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " T$i");
	    break;
	case ($value >= $pre['G']): 			//GIGA
	    $value   /= $pre['G'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " G$i");
	    break;
	case ($value >= $pre['G']*$threshold):
	    $value   /= $pre['G'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " G$i");
	    break;
	case ($value >= $pre['M']): 			//MEGA
	    $value   /= $pre['M'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " M$i");
	    break;
	case ($value >= $pre['M']*$threshold):
	    $value   /= $pre['M'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " M$i");
	    break;
	case ($value >= $pre['K']): 			//KILO
	    $value   /= $pre['K'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " $k$i");
	    break;
	case ($value >= $pre['K']*$threshold):
	    $value   /= $pre['K'];
	    $value   *= $sign;
	    return (sprintf("%01.2f", $value) . " $k$i");
	    break;
	default:
	    $value   *= $sign;
	    return sprintf("%01.2f", $value);
	    break;
    }
}


function create_rrd_table($report_id) {
    
    $enable_tmz = read_config_option('reportit_use_tmz');
    $tmz 	= ($enable_tmz) ? 'GMT' : date('T');

    // Create the sql syntax
    $sql = "CREATE TABLE reportit_rrdlist_" . $report_id . " ( 
	    id 			INT 		PRIMARY KEY,
            description         VARCHAR(255)    NOT NULL, 
	    start_day 		VARCHAR(255)	NOT NULL	DEFAULT 'Monday', 
	    end_day 		VARCHAR(255)	NOT NULL	DEFAULT 'Sunday',
	    start_time		TIME		NOT NULL	DEFAULT '00:00:00',
	    end_time		TIME		NOT NULL	DEFAULT '24:00:00',
	    timezone		VARCHAR(255)	NOT NULL	DEFAULT '$tmz'
	    )TYPE=MyISAM";    
    db_execute($sql);
}



function create_rvars_entries($variable_id, $template_id, $default) {
    $sql = "SELECT id FROM reportit_reports WHERE template_id=$template_id";
    $ids = db_fetch_assoc($sql);

    if(sizeof($ids > 0)) {
	$list = '';
	foreach($ids as $id) {
	    $list .= "($template_id, {$id['id']}, $variable_id, $default),";
	}
	
	//Remove last comma
	$list = substr($list, 0, strlen($list)-1);
	
	$sql = "INSERT INTO reportit_rvars (template_id, report_id, variable_id, value) VALUES $list";
	db_execute($sql); 
    }
}


function reset_report($report_id) {
    // Set report values last_run and runtime to zero
    db_execute("UPDATE reportit_reports SET last_run = '0', runtime = '0' WHERE id = '$report_id'");
}



function get_possible_rra_names($template_id) {
    //Get all possible names of the RRAs for this type of template
    $names = array();
    $array = array();
    
    $sql = "SELECT b.data_source_name FROM reportit_templates as a 
	    RIGHT JOIN data_template_rrd as b 
	    ON a.data_template_id = b.data_template_id 
	    WHERE b.local_data_id=0 AND a.id=$template_id";
    $names = db_fetch_assoc($sql);
    foreach($names as $name) {
	$array[] = $name['data_source_name'];
    }
    return $array;
}



function get_intersizes($measurand_id, $template_id, $ln = false) {
    // Fetch all intermediate results which have been defined before the current measurand
    $array 	= array();
    $names 	= array();
    $intersizes = array();    

    $names = get_possible_rra_names($template_id);
    $sql = "SELECT abbreviation, spanned
	    FROM reportit_measurands
	    WHERE template_id=$template_id ";
    if($measurand_id != 0) $sql .= "AND id<$measurand_id";
    $array = db_fetch_assoc($sql);
    
    foreach($array as $intersize) {
	if($intersize['spanned'] == 0) {
	    foreach($names as $name) {
		$intersizes[] = $intersize['abbreviation'] . ':' . $name;
	    }
	}
	if($ln) $intersize['abbreviation'] .= '<br>';
	$intersizes[] = $intersize['abbreviation'];
    }
    
    return $intersizes;
}


function get_possible_variables($template_id) {
    // Fetch all variables which has been defined for this template
    global $calc_var_names;
    $names = array();
    $array = array();

    // Check whether maxValue is valid
    $sql = "SELECT DISTINCT a.rrd_maximum FROM data_template_rrd as a 
	    INNER JOIN reportit_templates as b 
	    ON a.data_template_id = b.data_template_id AND b.id = $template_id 
	    WHERE a.local_data_id = 0";
    $maximum = db_fetch_cell($sql);
    if(!is_numeric($maximum) || $maximum == 0) unset($calc_var_names[0]);
    
    
    $sql = "SELECT abbreviation FROM reportit_variables WHERE template_id=$template_id";
    $names = db_fetch_assoc($sql);
    // and bring them toghter with the standard variables
        
    foreach($calc_var_names as $name) {
	$array[] = $name;
    }
    foreach($names as $name) {
            $array[] = $name['abbreviation'];
        }
    return array_flip($array);
}


function get_template_status($template_id) {
    //Returns '1' if the template has been locked.
    $sql = "SELECT locked FROM reportit_templates WHERE id=$template_id";
    $status = db_fetch_cell($sql);
    return $status;
}


function in_process($report_id, $status = 1) {
    $sql = "UPDATE reportit_reports SET in_process=$status WHERE id=$report_id";
    db_execute($sql);
}


function stat_process($report_id) {
    $sql = "SELECT in_process FROM reportit_reports WHERE id=$report_id";
    return db_fetch_cell($sql);
}


function config_date_format($no_time=TRUE) {
	$date_fmt = read_graph_config_option("default_date_format");
	$datechar = read_graph_config_option("default_datechar");

	if (!isset($date_fmt)) return("Y-m-d H:i:s");

	if ($datechar == GDC_HYPHEN) {
		$datechar = "-";
	}else {
		$datechar = "/";
	}

	switch ($date_fmt) {
		case GD_MO_D_Y:
			$dd = ("m" . $datechar . "d" . $datechar . "Y");
			break;
		case GD_MN_D_Y:
			$dd = ("M" . $datechar . "d" . $datechar . "Y");
			break;
		case GD_D_MO_Y:
			$dd = ("d" . $datechar . "m" . $datechar . "Y");
			break;
		case GD_D_MN_Y:
			$dd = ("d" . $datechar . "M" . $datechar . "Y");
			break;
		case GD_Y_MO_D:
			$dd = ("Y" . $datechar . "m" . $datechar . "d");
			break;
		case GD_Y_MN_D:
			$dd = ("Y" . $datechar . "M" . $datechar . "d");
			break;
		default:
			return ("Y-m-d H:i:s");
	}

	if (!$no_time)
		return ($dd . 'H:i:s');
	else
		return $dd;
}

?>