<?php
/*******************************************************************************

    Author ......... Andreas Braun
    Contact ........ browniebraun@cacti.cc
    Home Site ...... 
    Program ........ "ReportIt"
    Version ........ 0.4.2
    Purpose ........ Create reports

*******************************************************************************/


function plugin_init_reportit() {

    global $plugin_hooks;
    $plugin_hooks['top_header_tabs']	  ['reportit']	= 'reportit_show_tab';
    $plugin_hooks['top_graph_header_tabs']['reportit'] 	= 'reportit_show_tab';
    $plugin_hooks['draw_navigation_text'] ['reportit'] 	= 'reportit_draw_navigation_text';
    $plugin_hooks['config_arrays']	  ['reportit'] 	= 'reportit_config_arrays';
    $plugin_hooks['config_settings']	  ['reportit'] 	= 'reportit_config_settings';

}



function reportit_version ($specifically = FALSE) {

    $info = array('name'     	=> 'ReportIt',
    		'version'     	=> '0.4.2',
        	'longname'    	=> 'report it!',
        	'author'    	=> 'Andreas Braun',
        	'homepage'    	=> '',
        	'email'    	=> 'browniebraun@cacti.cc',
        	'url'        	=> ''
        	);

    $return = ($specifically === FALSE) ? $info : $info[$specifically];
    return $return;
}



function reportit_draw_navigation_text ($nav) {

    $nav["cc_reports.php:"] 			= array("title" => "Reports", "mapping" => "index.php:", "url" => "cc_reports.php", "level" => "1");
    $nav["cc_reports.php:save"]			= array("title" => "(Edit)", "mapping" => "index.php:,?", "url" => "cc_templates.php", "level" => "2");
    $nav["cc_reports.php:report_add"]		= array("title" => "Add", "mapping" => "index.php:,?", "url" => "cc_templates.php", "level" => "2");
    $nav["cc_reports.php:report_edit"]		= array("title" => "(Edit)", "mapping" => "index.php:,?", "url" => "cc_templates.php", "level" => "2");
    $nav["cc_reports.php:actions"]		= array("title" => "Actions", "mapping" => "index.php:,?", "url" => "cc_templates.php", "level" => "2");

    $nav["cc_rrdlist.php:"]			= array("title" => "Data Items", "mapping" => "index.php:,cc_reports.php:", "url" => "cc_templates.php", "level" => "2");
    $nav["cc_rrdlist.php:rrdlist_add"]		= array("title" => "Add", "mapping" => "index.php:,cc_reports.php:,cc_rrdlist.php:", "url" => "", "level" => "3");
    $nav["cc_rrdlist.php:save"]			= array("title" => "(Edit)", "mapping" => "index.php:,cc_reports.php:,cc_rrdlist.php:", "url" => "", "level" => "3");
    $nav["cc_rrdlist.php:rrdlist_edit"]		= array("title" => "(Edit)", "mapping" => "index.php:,cc_reports.php:,cc_rrdlist.php:", "url" => "", "level" => "3");
    $nav["cc_rrdlist.php:actions"]		= array("title" => "Actions", "mapping" => "index.php:,cc_reports.php:,cc_rrdlist.php:", "url" => "", "level" => "3");

    $nav["cc_templates.php:"] 			= array("title" => "Report Templates", "mapping" => "index.php:", "url" => "cc_templates.php", "level" => "1");
    $nav["cc_templates.php:save"] 		= array("title" => "(Edit)", "mapping" => "index.php:,cc_templates.php:", "url" => "", "level" => "2");
    $nav["cc_templates.php:template_edit"] 	= array("title" => "(Edit)", "mapping" => "index.php:,cc_templates.php:", "url" => "", "level" => "2");
    $nav["cc_templates.php:template_add"]	= array("title" => "Add", "mapping" => "index.php:,cc_templates.php:", "url" => "", "level" => "2");
    $nav["cc_templates.php:actions"] 		= array("title" => "Actions", "mapping" => "index.php:,cc_templates.php:", "url" => "", "level" => "2");

    $nav["cc_measurands.php:"]			= array("title" => "Measurands", "mapping" => "index.php:,cc_templates.php:", "url" => "cc_templates.php", "level" => "2");
    $nav["cc_measurands.php:save"]		= array("title" => "(Edit)", "mapping" => "index.php:,cc_templates.php:,cc_measurands.php:", "url" => "", "level" => "3");
    $nav["cc_measurands.php:measurand_edit"]	= array("title" => "(Edit)", "mapping" => "index.php:,cc_templates.php:,cc_measurands.php:", "url" => "", "level" => "3");
    $nav["cc_measurands.php:actions"]		= array("title" => "Actions", "mapping" => "index.php:,cc_templates.php:,cc_measurands.php:", "url" => "", "level" => "3");

    $nav["cc_variables.php:"]			= array("title" => "Variables", "mapping" => "index.php:,cc_templates.php:", "url" => "cc_templates.php", "level" => "2");
    $nav["cc_variables.php:save"]		= array("title" => "(Edit)", "mapping" => "index.php:,cc_templates.php:,cc_variables.php:", "url" => "", "level" => "3");
    $nav["cc_variables.php:variable_edit"]	= array("title" => "(Edit)", "mapping" => "index.php:,cc_templates.php:,cc_variables.php:", "url" => "", "level" => "3");
    $nav["cc_variables.php:actions"]		= array("title" => "Actions", "mapping" => "index.php:,cc_templates.php:,cc_variables.php:", "url" => "", "level" => "3");

    $nav["cc_run.php:calculation"] 		= array("title" => "Report Calculation", "mapping" => "index.php:,cc_reports.php:", "url" => "", "level" => "2");

    $nav["cc_view.php:"] 			= array("title" => "Public Reports", "mapping" => "index.php:", "url" => "cc_view.php", "level" => "1");
    $nav["cc_view.php:show_report"]		= array("title" => "Show Report", "mapping" => "index.php:,cc_view.php:", "url" => "", "level" => "2");
    $nav["cc_view.php:export"]			= array("title" => "Export Report", "mapping" => "index.php:,cc_view.php:", "url" => "", "level" => "2");


    return $nav;
}



function reportit_config_arrays () {

    global $user_auth_realms, $user_auth_realm_filenames, $menu;

    $realm_id_1 						= 800;
    $realm_id_2 						= 801;
    $realm_id_3 						= 802;

    $user_auth_realms[$realm_id_1]				= 'Plugin -> Reports: Power User Configuration';
    $user_auth_realms[$realm_id_2]				= 'Plugin -> Reports: Owner Configuration';
    $user_auth_realms[$realm_id_3]				= 'Plugin -> Reports: View';

    $user_auth_realm_filenames['cc_templates.php']		= $realm_id_1;
    $user_auth_realm_filenames['cc_measurands.php']		= $realm_id_1;
    $user_auth_realm_filenames['cc_variables.php'] 		= $realm_id_1;
    $user_auth_realm_filenames['cc_reports.php']		= $realm_id_2;
    $user_auth_realm_filenames['cc_rrdlist.php']		= $realm_id_2;
    $user_auth_realm_filenames['cc_run.php']			= $realm_id_2;
    $user_auth_realm_filenames['cc_view.php'] 			= $realm_id_3;

    $menu["Management"]	['plugins/reportit/cc_reports.php'] 	= "Reports";
    $menu["Templates"]	['plugins/reportit/cc_templates.php']	= "Report Templates";
}



function reportit_config_settings () {

    global $tabs, $tabs_graphs, $settings, $graph_dateformats, $graph_datechar, $settings_graphs;

    $datetime			=  array('local', 'global');
    $csv_column_seperator 	=  array(",", ";", "Tab", "Blank");
    $csv_decimal_seperator	=  array(",", ".");
    $rrdtool_api		=  array('PHP BINDINGS (FAST)', 'RRDTOOL CACTI (SLOW)', 'RRDTOOL SERVER (SLOW)');

    $tabs["reports"] 		=  "Reports";

    $temp 			=  array(
        "reportit_header"	=> array(
            "friendly_name" 	=> "General",
            "method"		=> "spacer",
            ),
	"reportit_met"		=> array(
	    "friendly_name"	=> "Maximum Execution Time (in seconds)",
	    "description"	=> "Optional: Maximum execution time of one calculation",
	    "method"		=> "textbox",
	    "max_length"	=> "4",
	    "default"		=> "300",
	    ),
	"reportit_use_tmz"	=> array(
	    "friendly_name"	=> "Time Zones",
	    "description"	=> "Enable/disable the use of time zones for data item's<br>"
				    ."configuration and report calculation.<br>"
				    ."In the former case server time has to be set up to GMT/UTC!",
	    "method"		=> "checkbox",
	    "default"		=> "off",
	    ),
	"reportit_show_tmz"	=> array(
	    "friendly_name"	=> "Show Local Time Zone",
	    "description"	=> "Enable/disable to display server's timezone on the headlines.",
	    "method"		=> "checkbox",
	    "default"		=> "on",
	    ),
	"reportit_use_IEC"	=> array(
	    "friendly_name"	=> "SI-Prefixes",
	    "description"	=> "Enable/disable the use of correct SI-Prefixes for binary multiples<br>"
				    ."under the terms of <a href='http://www.ieee.org'>IEEE 1541</a>"
				    ." and <a href='http://www.iec.ch/zone/si/si_bytes.htm'>IEC 60027-2</a>.",
	    "method"		=> "checkbox",
	    "default"		=> "on",
	    ),
        "reportit_header2"	=> array(
            "friendly_name" 	=> "RRDtool",
            "method"		=> "spacer",
            ),
        "reportit_API" 		=> array(
            "friendly_name" 	=> "RRDtool Connection",
            "description" 	=> "Choose the way to connect to RRDtool.",
            "method" 		=> "drop_array",
	    "array"		=> $rrdtool_api,
	    "default"		=> "1",
	    ),
	"reportit_RRDID"	=> array(
	    "friendly_name"	=> "RRDtool Server IP",
	    "description"	=> "Optional: Configured IP address of the RRDtool server.",
	    "method"		=> "textbox",
	    "max_length"	=> "15",
	    "default"		=> "127.0.0.1",
	    ),
	"reportit_RRDPort" 	=> array(
	    "friendly_name"	=> "RRDtool Server Port",
	    "description"	=> "Optional: Configured port setting of RRDtool server.",
	    "method"		=> "textbox",
	    "max_length"	=> "5",
	    "default"		=> "13900",
	    ),
        "reportit_header3"	=> array(
            "friendly_name" 	=> "Export Settings",
            "method"		=> "spacer",
            ),
        "reportit_csv" 		=> array(
            "friendly_name" 	=> "Enable CSV export",
            "description" 	=> "Enable/disable CSV export functionality",
            "method" 		=> "checkbox",
            "default" 		=> "off",
            ),
        "reportit_filename" 	=> array(
            "friendly_name" 	=> "Filename Format",
            "description" 	=> "The name format for the export files.",
	    "max_length"	=> "100",
            "method" 		=> "textbox",
	    "default"		=> "cacti_report<report_id>",
	    ),
	"reportit_exp_header" 	=> array(
            "friendly_name" 	=> "Export Header",
            "description" 	=> "The header description for export files",
            "method" 		=> "textarea",
	    "textarea_rows"	=> "3",
	    "textarea_cols"	=> "60",
	    "default"		=> "# Your default header\n# <cacti_version> <reportit_version>",
	    ),
    );


    if (isset($settings["reports"]))
        $settings["reports"]=array_merge($settings_graphs, $temp);
    else
        $settings["reports"]=$temp;
    unset($temp);

    //Extension of graph settings
    $tabs_graphs['reportit']= 'Report Settings';
    $temp 			=  array(
        "reportit_csv_column_s" => array(
            "friendly_name" 	=> "Column Separator",
            "description" 	=> "The column seperator to be used for CSV exports",
            "method" 		=> "drop_array",
	    "array"		=> $csv_column_seperator,
	    "default"		=> '1',
	    ),
        "reportit_csv_decimal_s"=> array(
            "friendly_name" 	=> "Decimal Separator",
            "description" 	=> "The symbol indicating the end of the integer part and the beginning of the fractional part",
            "method" 		=> "drop_array",
	    "array"		=> $csv_decimal_seperator,
	    "default"		=> '0',
	    ),
    );

    if (isset($settings_graphs["reports"]))
        $settings_graphs['reportit'] = array_merge($settings_graphs['reportit'],$temp);
    else
        $settings_graphs['reportit']=$temp;
    unset($temp);
}



function reportit_show_tab () {

    global $config, $user_auth_realms, $user_auth_realm_filenames;
    $realm_id2 = 0;

    if (isset($user_auth_realm_filenames{basename('cc_view.php')})) {
        $realm_id2 = $user_auth_realm_filenames{basename('cc_view.php')};
    }
    if ((db_fetch_assoc(
	"select user_auth_realm.realm_id
    	 from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
	 and user_auth_realm.realm_id='$realm_id2'"
	 )) || (empty($realm_id2))) {
        print '<a href="' . $config['url_path'] . 'plugins/reportit/cc_view.php"><img src="' . $config['url_path'] . 'plugins/reportit/images/tab_reportit.gif" alt="reportit" align="absmiddle" border="0"></a>';
    }
    reportit_setup_table();
}



function reportit_setup_table () {

    global $config, $database_default;
    include_once($config["library_path"] . "/database.php");

    $sql	= "show tables from " . $database_default;
    $result 	= db_fetch_assoc($sql) or die (mysql_error());
    $tables 	= array();
    $sql 	= array();

    foreach($result as $index => $arr) {
        foreach($arr as $tbl) {
            $tables[] = $tbl;
        }
    }

    if (!in_array('reportit_reports', $tables)) {
        $sql[] = "CREATE TABLE reportit_reports (
                    id 			INT 	     NOT NULL AUTO_INCREMENT PRIMARY KEY,
                    description 	VARCHAR(255) NOT NULL,
		    user_id		INT	     NOT NULL,
		    template_id		INT	     NOT NULL,
		    preset_timespan	VARCHAR(255) NOT NULL,
		    last_run		DATETIME     NOT NULL,
		    runtime		INT	     NOT NULL,
		    public		TINYINT(1)   NOT NULL,
		    start_date		DATE	     NOT NULL,
		    end_date		DATE	     NOT NULL,
		    ds_description	VARCHAR(255) NOT NULL,
		    rs_def		VARCHAR(255) NOT NULL,
		    sp_def 		VARCHAR(255) NOT NULL,
		    sliding		TINYINT(1)   NOT NULL DEFAULT '0',
		    present		TINYINT(1)   NOT NULL DEFAULT '0',
		    scheduled		TINYINT(1)   NOT NULL DEFAULT '0',
		    subhead		TINYINT(1)   NOT NULL DEFAULT '0',
		    in_process		TINYINT(1)   NOT NULL DEFAULT '0',
		    frequency		VARCHAR(225) NOT NULL
                  )TYPE=MyISAM;";
    }

    if (!in_array('reportit_templates', $tables)) {
        $sql[] = "CREATE TABLE reportit_templates (
                    id 			INT 	     NOT NULL AUTO_INCREMENT PRIMARY KEY,
		    description		VARCHAR(255) NOT NULL,
		    pre_filter		VARCHAR(255) NOT NULL,
		    data_template_id	INT	     NOT NULL,
		    cf			INT          NOT NULL DEFAULT '1',
		    locked		TINYINT(1)   NOT NULL DEFAULT '0'
                  )TYPE=MyISAM;";
    }

    if (!in_array('reportit_measurands', $tables)) {
        $sql[] = "CREATE TABLE reportit_measurands (
                    id 			INT 	     NOT NULL AUTO_INCREMENT PRIMARY KEY,
		    template_id		INT	     NOT NULL,
		    description		VARCHAR(255) NOT NULL,
		    abbreviation	VARCHAR(255) NOT NULL,
		    calc_formula	VARCHAR(255) NOT NULL,
		    unit		VARCHAR(255) NOT NULL,
		    visible		TINYINT(1)   NOT NULL DEFAULT '1',
                    spanned		TINYINT(1)   NOT NULL DEFAULT '0',
		    rounding		TINYINT(1)   NOT NULL
                  )TYPE=MyISAM;";
    }

    if (!in_array('reportit_variables', $tables)) {
        $sql[] = "CREATE TABLE reportit_variables (
                    id 			INT 	     NOT NULL AUTO_INCREMENT PRIMARY KEY,
		    template_id		INT	     NOT NULL,
                    abbreviation        VARCHAR(255) NOT NULL,
		    name		VARCHAR(255) NOT NULL,
		    description		VARCHAR(255) NOT NULL,
		    max_value		FLOAT 	     NOT NULL,
		    min_value		FLOAT	     NOT NULL,
		    default_value	FLOAT	     NOT NULL,
		    input_type		TINYINT(1)   NOT NULL,
		    stepping		FLOAT  	     NOT NULL
                  )TYPE=MyISAM;";
    }

    if (!in_array('reportit_rvars', $tables)) {
        $sql[] = "CREATE TABLE reportit_rvars (
                    id 			INT 	     NOT NULL AUTO_INCREMENT PRIMARY KEY,
		    template_id		INT	     NOT NULL,
		    report_id		INT	     NOT NULL,
		    variable_id		INT	     NOT NULL,
		    value		FLOAT	     NOT NULL
		  )TYPE=MyISAM;";
    }

    if (!empty($sql)) {
	for ($a = 0; $a < count($sql); $a++) {
	    $result = mysql_query($sql[$a]);
	}
    }
}

?>
